	
	.z80		
	.xlist

; ****************************************************************
; *								 *
; * MODUL	DEFAULT.INC					 *
; * REL		2.2 			860305			 *
; * 								 *
; * Dieses Programmsegment enthaelt ALLE hardware-abhaengigen	 *
; * Daten die zur Generierung eines CP/M3 Systemes notwendig	 *
; * sind.							 *
; * 								 *
; * Im Normalfalle muss NUR DIESE Datei geaendert werden um	 *
; * ein System Benutzerspezifisch anzupassen.			 *
; *								 *
; * Innerhalb DIESES Programmsegmentes sind verschiedene Arten 	 *
; * von LABELS (MARKEN) zu unterscheiden:			 *
; *								 *
; *	1.	Assemblerdirektiven				 *
; *		diese LABELS steuern einen gewuenschten		 *
; *		Assemblerdurchlauf				 *
; *								 *
; *	2.	Hardwaredirektiven				 *
; *		diese LABELS binden eine gewuenschte hardware	 *
; *		in das zu generierende System ein		 *
; *								 *
; *	3.	Portanweisungen					 *
; *		diese LABEL bestimmen die hardware-PORTS der	 *
; *		einzelnen Systemkarten. Diese Adressen sind	 *
; *		aus Gruenden der Kompatibilitaet moeglichst	 *
; *		unveraendert zu lassen.				 *
; *								 *
; *	4.	Befehle und Masken				 *
; *		hier handelt es sich um bestimmte Steuerbefehle	 *
; *		and LSI-Bausteine im System oder um Masken	 *
; *		zu Statusabfragen.				 *
; *								 *
; * Dieses Programmsegment ist VOR-EINGESTELLT zur Bearbeitung	 *
; * mit dem SRL-Z80-Assembler. Ist dieser Assembler nicht ver-	 *
; * fuegbar ist das LABEL Z80ASM auf den Wert NEIN zu setzen.	 *
; * In diesem Falle muessen alle mit GROSSBUCHSTABEN ge-	 *
; * schriebenen LABELS ... PER HAND ... an die spezifische	 *
; * hardware-Konfiguration angepasst werden, bei SRL-Z80-	 *
; * Assembler werden die Werte dagegen beim Assemblerdurchlauf 	 *
; * abgefragt.							 *
; *								 *
; * WICHTIG: Wird MACRO-80 (MICROSOFT) verwendet MUSS unbedingt  *
; * 	     eine VERSION 3.34 oder spaeter (LONG-LABELS) ver-	 *
; *	     wendet werden. Ist diese Version nicht greifbar     *
; *          muessen ALLE Labels auf 8 Zeichen reduziert werden  *
; *          UND die MACROS in CPM3.INC (fuer XDPH und DPB) PER  *
; *	     Hand aufgeloest werden.				 *
; *	     Inwieweit andere Z80-Assembler 'brauchbar' sind 	 *
; *          ist ungetestet. 				         *
; *								 *	
; * Besonderheiten und 'fragliches' sind kommentiert		 *
; *								 *
; * geschrieben von RAOUL O. KOERBER, Detmold			 *
; *								 *
; ****************************************************************
	
	;
	; Steueranweisungen
	;

ja	equ	-1
nein	equ	not ja

cpuiec	equ	ja		; Immer von Hand zu setzen !
fdc4	equ	nein		; dto

	;
	; Revisionsangaben
	; USR ist gedacht fuer Versionen gleicher REL/REV in
	; welcher z.B. nur andersartige hardware eingebunden ist
	; Die Nummerierung bleibt dem Benutzer ueberlassen
	;

rel	equ	'2'		; Release
rev	equ	'1'		; Revision
usr	equ	'0'		; Sonderversion von REL-REV

	;
	; Bankanweiung UNVERAENDERLICH!
	;

banked	equ	ja

   if	banked

tpa$bank equ	1		; gebankt ist TPA auf Bank 1

   else

tpa$bank equ	0		; sonst auf Bank 0 ( wo sonst )

   endif

	;
	; Assembler
	;

z80asm	equ	ja		; nein bei MACRO-80

	;
	; ****************
	; * CPU		 *
	; ****************
	;
	;
	; Es kann prinzipiell jede ELZET-80 CPU in das ELZET-80 BIOS
	; eingebunden werden. Problematisch wird dabei nur die Zuweisung
	; der Konsolen-Schnittstelle. Diese muss (sinnvollerweise) auch
	; vom Monitorprogramm (SSM) angesprochen werden. Ueber die ent-
	; sprechende Schnittstelle erfolgt IMMER die Konsoleneingabe.
	; Die Konsolenausgabe ist von der Praesenz der VIDEO-80-Karte
	; abhaengig. Die Ausgabe erfolgt ueber VIDEO-80 falls diese 
	; Karte im System ist, sonst erfolgt die Ausgabe ueber den 
	; entsprechenden SIO-Kanal
	;
	; SSM3 spricht die CPU/IEC und CPU/PRO sowie die CPU (mit 8251) an,
	; diese CPU-Karten (bzw deren Schnittstellen) werden automatisch
	; erkannt. [ Bei SIO ist IMMER Kanal <B> der Standard EIN/AUSgabe-
	; Kanal ]
	;
	; Ab SSM4 werden folgende Schnittstellen erkannt:
	;
	;	1.	SIO (Kanal B) der CPU/IEC
	;	2.	SCC der CPU85SC und CPU/S
	;
	; es wird nach dem Label CPUIEC entschieden ob diese
	; CPU oder eine CPU aus der neuen S-Serie im Geraet ist
	; dieses Label ist IMMER von Hand zu setzten


	;
	; ****************
	; * Konsole	 *
	; ****************
	;

	;
	; Die Standard-Eingabe erfolgt ueber die Serienschnittstelle
	; der System-CPU-Karte
	;

   if	cpuiec

p$csad	equ	04h		; SIO Kanal A Daten
p$csbd	equ	05h		; SIO Kanal B Daten ( Standard)
p$csac	equ	06h		; SIO Kanal A Status
p$csbc	equ	07h		; SIO Kanal B Status (Standard)

   else

p$csbc	equ	00h		; SCC Kanal B Status (Standard)
p$csbd	equ	01h		; SCC Kanal B Daten  (Standard)
p$csac	equ	02h		; SCC Kanal A Status 
p$csad	equ	03h		; SCC Kanal A Daten
p$csta	equ	0fh		; Status Port (Bank-Select)

   endif	

	;
	; Die Standard-Ausgabe erfolgt ueber VIDEO-80 (falls vorhanden)
	; sonst ueber den SIO (SCC)-Kanal ueber welchen die Eingabe
	; erfolgt
	;

	;
	; ****************
	; * VIDEO-80	 *
	; ****************
	;
	
	;
	; falls VIDEO-80 nicht im System eingebunden ist, kann
	; durch nachfolgendes FLAG aller VIDEO-80 relevanter Code
	; entfernt werden
	;

   if	not z80asm

VIDEO80	equ	nein		;ja

   endif

	;
	; es sind 2 VIDEO-Treiber-Programme lieferbar
	; V80.Z80 (MAC) ist ein kleiner,schneller Treiber
	; der im residenten RAM-Bereich arbeitet und
	; V83.Z80 (MAC) mit wesentlich erweitertem Befehls-
	; satz (optionel gegen Mehrpreis!), Dieser Treiber
	; arbeitet im gebankten Bereich. 
	;

   if	not z80asm

V83FLG	equ	nein

   endif
 
p$vtog	equ	28h		; Window-Port
p$vreg	equ	2ah		; Registeradresse
p$vfil	equ	2bh		; interne Register

aram	equ	0e000h		; Attributspeicher
vram	equ	aram+800H	; Videospeicher
nrow	equ	24		; Anzahl der Zeilen (ohne Statuszeile!)
ncol	equ	80		; Anzahl der Spalten pro Zeile
screen$len equ	ncol*nrow	; 'Laenge' des Videorams
screen$end equ  vram+screen$len ; letzte Bildschirm-Position

	;
	; ****************
	; * Drucker	 *
	; ****************
	;

	; Im Standard-Paket sind zwei Druckertreiber vorgesehen
	; Als Vorgabewert ist die serielle Schnittstelle via
	; Kanal A der RS232-Schnittstelle vorgesehen. 
	; Entsprechend dem folgenden Label PPRINT koennen die
	; Systemkarten PRINT,PRINT/CTC und PRINT/UHR als CENTRONIC-
	; Schnittstelle eingebunden werden. Die RS232-Schnittstelle
	; ist dann ueber DEVICE waehlbar
	;

   if	not z80asm

PPRINT	equ	nein	;ja

   endif

	;
	; **** PRINT/CTC und PRINT/UHR - Bei PRINT gelten NUR PIO-Ports
	;

p$ctc0	equ	20h		; CTC Kanal 0
p$ctc1	equ	21h		; CTC Kanal 1
p$ctc2	equ	22h		; CTC Kanal 2 (frei)
p$ctc3	equ	23h		; CTC Kanal 3

p$pcon	equ	24h		; Kontrollport CENTRONIC
p$pdat	equ	25h		; Datenport CENTRONIC
p$pac	equ	26h		; PIO A Initport
p$pbc	equ	27h		; PIO B Initport

tim25	equ	78		; cpu 2.5 mhz		
tim40	equ	125		;     4    "		
tim60	equ	187		;     6    "		
cntcon	equ	125					

timer	equ	00110101B				
counter	equ	11000101B				
resctc	equ	00000011B				

	;
	; ****************
	; * DISKIO	 *
	; ****************
	;
	; Laufwerkszuweisung
	;
	; Ab Version  2 des ELZET-80 BIOS werden fuer ELZET-80-Rechner
	; nur noch 
	;
	;	1.	8"-Laufwerke einseitig sd und dd sowie
	;			     zweiseitig dd
	; und	2.	5 1/4" oder 3 1/2" Laufwerke
	;			     zweiseitig dd 80 Track
	; direkt in das BIOS eingebunden. 
	; 
	; Alle notwendigen Daten fuer 40-Track Laufwerke
	; ein- oder zweiseitig dd sind auf Anforderung lieferbar
	; koennen gegen Mehrpreis (bitte Anfragen) auch eingebunden
	; werden, gehoeren jedoch NICHT zum Lieferumfang.
	;
	; HARD-Disk und RAM-Floppy stehen zur Verfuegung gehoeren jedoch
	; ebenfalls nicht zum normalen Lieferumfang.
	;
	; Entsprechend stehen folgende LABELS zur Systemgenerierung zur
	; Verfuegung:
	;

maxi	equ	00001111b	; 8" Lauferke ein- oder zweiseitig
t80d	equ	00011111b	; 5" und 3" 80 Track 2-seitig
hard	equ	00000001b	; Harddisk
rdisk	equ	00000010b	; RAM-Floppy
	
	; fuer Sonderanwendungen

t40s	equ	01010011b	; 40 Track 1-seitig ELZET-Format

	; Kennungen

ismaxi	defl	nein
ist80d	defl	nein
ishard	defl	nein
irdisk	defl	nein
ist40s	defl	nein

	;
	; Es koennen pro Kontroller vier Laufwerke vorbestimmt
	; werden. ( Laufwerk A-B-C-D ) RAM-Disk ist als Laufwerk E
	; festgelegt und Harddisk als Laufwerk F.
	;
	; Die Laufwerke G..P werden jeweils als Laufwerk B,C oder D selektiert
	; jedoch mit besonderen hardware-Spezifikationen. 
	;

  if	not z80asm

ADISK	equ	t80d	;maxi
BDISK	equ	t80d	;maxi
CDISK	equ	nein
DDISK	equ	nein
EDISK	equ	nein
FDISK	equ	nein

  endif

	;
	; es stehen vorlaeufig neun TRACK-Umschaltverfahren zur
	; Verfuegung: 
	;

form0	equ	0		; 1-seitige Laufwerke
form1	equ	00000100b	; ELZET-Format
form2	equ	00001000b	; NDR-Format	 (0/1Track/side)
form3	equ	00001100b	; IBM-Format	 (40Track*2)
form4	equ	00010000b	; Kontron Format (77Track*2)
form5	equ	00010100b	; NCR-decisionmate
form6	equ	00011000b	; BBC Acorn
form7	equ	00011100b	; Krause-Format (invertiert!)
form8	equ	00100000b	; alphatronic p3/p4
	
	; bist FORM 64 moeglich - wer braucht das aber schon ...
	

	; **** Portadressen

FDC3	equ	ja		; von Hand setzen

   if	FDC3

p$fdma	equ	60h		; DMA-Adresse
p$fcmd	equ	68h		; Befehlsregister
p$fstat	equ	68h		; Statusregister
p$ftrk	equ	69h		; Trackregister
p$fsec	equ	6ah		; Sektorregister
p$fdat	equ	6bh		; Datenregister
p$fpsel	equ	6ch		; Diskselekt
p$fpbnk	equ	6dh		; Bankselekt (bit 0..3)
p$fpac	equ	6eh		; PIO Kanal A INIT
p$fpbc	equ	6fh		; PIO Kanal B INIT

   else

				; NACHTRAG folgt

   endif

	; **** FDC-Befehlssatz

c$home	equ	00001100b	; STEP HOME 3 ms
c$seek	equ	00011100b	; SEEK 3ms
c$stpo	equ	01101100b	; STEP-OUT (nach TRACK0) 3ms
c$stpi	equ	01011100b	; STEP-IN (nach innen) 3ms

c$read	equ	10000100b	; Lesen TRACK
c$write	equ	10100100b	; Schreiben TRACK
c$getid	equ	11000100b	; lesen ID-Feld
c$moff	equ	00001111b	; Motor ausschalten

c$6ms	equ	00000001b	; 6ms step
c$10ms	equ	00000010b	; 10 ms step
c$15ms	equ	00000011b	; 15 ms step

c$dainc	equ	00010100b	; DMA Port A memory inc
c$dbfix	equ	00101000b	;     Port B fest
c$dbyte equ	10000101b	;     Byte mode
c$drish	equ	10001010b	;     Ready ist aktiv HIGH

c$dload	equ	11001111b	;     Laden
c$denab	equ	10000111b	;     enable DMA
c$ddisa	equ	10000011b	;     disable DMA
c$dread	equ	01111001b	;     lesen

c$dwrit	equ	01111101b	;     schreiben
c$pout	equ	00001111b	; PIO als Ausgabeport
c$pin	equ	01001111b	;     als Eingabeport
c$pbyt	equ	10001111b	;     im BYTE-Modus

c$pbit	equ	11001111b	;     im BIT-Modus
c$pnoin equ	00000111b	;     disable Interrupt

_alw	equ	00001110b	; Selekt Laufwerk A
_blw	equ	00001101b	;        Laufwerk B
_clw	equ	00001011b	; 	 Laufwerk C
_dlw	equ	00000111b	;        Laufwerk D

_ss	equ	01000000b	; Laufwerk single-sided
_sden	equ	10000000b	; single density

	;
	; ****************
	; * ASCII	 *
	; ****************
	;

	;
	; Nachfolgend die EQUATES fuer haeufig verwendete ASCII-Zeichen
	;

null	equ	0
ctlq	equ	'Q'-'@'
ctls	equ	'S'-'@'
bell	equ	07h		; Treiber in VIDEO-80 einbinden!
bs	equ	08h		; Backspace
ht	equ	09h		; Cursor rechts
lf	equ	0ah		; Zeilenvorschub (linefeed)
vt	equ	0bh		; Cursor eine Zeile hoch
ff	equ	0ch		; Cursor rechts 
cr	equ	0dh		; Wagenvorlauf (RETURN)
syn	equ	16h		; Cursor eine Zeile nach unten (kein Scroll)
sub	equ	1ah		; Bildschirm loeschen (CLS)
esc	equ	1bh		; ESCAPE
fs	equ	1ch		; CURSOR aus
gs	equ	1dh		; CURSOR ein
chome	equ	1eh		; Cursor nach oben links ohne loeschen
newline equ	1fh		; CR und LF
crls	equ	01a0ch		; CLS fuer ADM3A UND TVI in Startzeile
blank	equ	20h		; Leerzeichen
delete	equ	07fh		; DELETE

	;
	; ****************
	; * RS232        *
	; ****************
	;

	;
	; Im ELZET-80 BIOS koennen unterschiedliche Serienschnittstellen
	; (neben der CPU-Schnittstelle) eingebunden werden.
	; Als Standard sind folgende Karten einbindbar:
	;

SIO2	equ	JA
SCC2	equ	NOT SIO2	; entweder oder
SIO6	equ	NEIN		;JA

   if	sio2

p$sad	equ	10h		; Kanal A Daten
p$sbd	equ	p$sad+1		; Kanal B Daten
p$sac	equ	p$sad+2		; Kanal A Status
p$sbc	equ	p$sad+3		; Kanal B Status
   else	
p$cioc	equ	10h		; SCC-2 Karte
p$sbc	equ	p$cioc+4
p$sac 	equ	p$cioc+5
p$sbd	equ	p$cioc+6
p$sad	equ	p$cioc+7

  endif

p$ssad	equ	30h		; SIO-6 Kanaele A..F
p$ssbd	equ	p$sad+1
p$ssac	equ	p$sad+2
p$ssbc	equ	p$sad+3
p$sscd	equ	p$sad+4
p$ssdd	equ	p$sad+5
p$sscc	equ	p$sad+6
p$ssdc	equ	p$sad+7
p$ssed	equ	p$sad+8
p$ssfd	equ	p$sad+9
p$ssec	equ	p$sad+10
p$ssfc	equ	p$sad+11
p$sctc0	equ	p$sad+12	; SIO-6 CTC fuer Baudrate
p$sctc1	equ	p$sad+13
p$sctc2	equ	p$sad+14
p$sctc3	equ	p$sad+15

	;
	; ****************
	; * Baudrate     *
	; ****************
	;
	
	;
	; CP/M3 ermoeglicht es die Baudrate fuer Serielle Schnittstellen
	; (via DEVICE.COM) umzuschalten. Hierzu sind einige FLAGS
	; vordefiniert.
	;

	; **** Definition der Schnittstelle

mb$input	equ	00000001b	; EINGABE Einheit
mb$output	equ	00000010b	; AUSGABE Einheit
mb$in$out	equ	mb$input+mb$output	; EIN/AUSGABE Einheit
mb$soft$baud	equ	00000100b	; Baudrate ueber Software waehlbar
mb$serial	equ	00001000b	; Serienport evtl mit Protokoll
mb$xon$xoff	equ	00010000b	; mit xon/xoff Protocol 

	;	
	; **** Definition der Baudrate
	; Die Baudraten-Umschaltung ist hardware-abhaengig
	; Fehlerehafte Zuweisung ueber DEVICE.COM ist leider
	; moeglich - - - 
	;

baud$none	equ	0		; keine Baudrate 
baud$50		equ	1		; 50 baud
baud$75		equ	2		; 75 baud
baud$110	equ	3		; 110 baud
baud$134	equ	4		; 134.5 baud
baud$150	equ	5		; 150 baud
baud$300	equ	6		; 300 baud
baud$600	equ	7		; 600 baud
baud$1200	equ	8		; 1200 baud
baud$1800	equ	9		; 1800 baud
baud$2400	equ	10		; 2400 baud
baud$3600	equ	11		; 3600 baud
baud$4800	equ	12		; 4800 baud
baud$7200	equ	13		; 7200 baud
baud$9600	equ	14		; 9600 baud
baud$19200	equ	15		; 19.2k baud

	;
	; ****************
	; * XMOVE-Puffer *
	; ****************
	;

	;
	; der XMOVE-Puffer (Interbank-Puffer) wird im ELZET-80
	; BIOS fest ab Adresse 0FD00H in einer Laenge von 200H
	; eingebunden. 
	; Will der Benutzer hier etwas aendern ist in CPM3.DAT die
	; Obergrenze des SYSTEM-RAMs entsprechend anzupassen.
	;
	
a$bbuf	equ	0fd00h		; Startadresse XMOVE-Puffer
a$bend	equ	0ff00h		; Endadresse+1 des XMOVE-Puffer
a$blen	equ	a$bend-a$bbuf	; Laenge des XMOVE-Puffers

	;
	; ****************
	; * CCP-Bank	 *
	; ****************
	;

	;
	; Der CCP ist im ELZET-80-BIOS auf Bank 0 ab Adresse
	; 0D000H untergebracht, wohin er sofort nach dem Booten
	; transveriert wird.
	;
	; ACHTUNG: Dieser Bereich ist anzupassen wenn ein gemeinsamer
	; Speicherbereich von mehr als 8K (COMMON) verwendet wird.
	; Die Obergrenze des gebankten CP/M3-Teiles ist darueberhinaus
	; in CPM3.DAT festgelegt (also auch dort anzupassen)
	;

ccpbnk	equ	0		; Bank
ccpis	equ	0d000h		; Startadresse des CCP
ccplen	equ	00d00h		; Laenge des CCP

bdos	equ	0005h		; Einsprungadresse BDOS
tpa	equ	100h	

	;
	; ****************
	; * Interrupt	 *
	; ****************
	;

	; Alle Interrupt-Vektoren liegen FEST ab Adresse 0FF00h
	; es sind 8 Vektoren zulaessig, wobei die ersten 3 fuer
	; CP/M reserviert sind.

	;
	; Interrupt darf erst nach Booten des CP/M3-Systems initialisiert
	; werden. Die Serviceroutine muss im gemeinsamen Bereich liegen
	; Hierzu ist evtl. ein PATCH-Bereich vorzusehen. Es ist zu
	; bedenken, dass Interrupts ein System inkompatibel machen.
	; Fuer Interrupts im MINUTEN-Takt kann aus HIGH-LEVEL-Programmen
	; evtl. auf den Minuten-Takt der UHR zurueckgegriffen werden
	;

ivect	equ	0ff00h
ivect0	equ	ivect		; reserviert fuer Floppy-Interrupt
ivect1	equ	ivect+2		; reserviert fuer UHR
ivect2	equ	ivect+4		; reserviert fuer UHR
ivect3	equ	ivect+6		; FREI
ivect4	equ	ivect+8		; FREI
ivect5	equ	ivect+10	; FREI
ivect6	equ	ivect+12	; FREI
ivect7	equ	ivect+14	; FREI

	;
	; ACHTUNG: Die Interrupt-Service-Routine MUSS UNBEDINGT
	; im gemeinsamen (COMMON-CSEG) Speicherbereich liegen, da
	; CP/M3 ( im gebankten System ) fuer den Benutzer unkontrollierbar
	; die Banks umschaltet.
	;
	;
	; Der Bereich von ivect+16 bis ivect+239 kann als
	; Patchbereich verwendet werden. Auf diesen Bereich
	; greift weder CP/M noch das BIOS zu.   
	;

	.list

