	title 	'CP/M 3 BIOS fuer ELZET-80 Computer'
	subttl 	RDISK  Treiber fuer RAM-Floppy
	page	
;****************************************************************
;*								*
;*  RAM-FLOPPY fuer ELZET-80 CP/M3-Systeme			*
;*								*
;*  rel 1.1		850916					*
;*								*
;* Copyright (C)  Raoul O. Koerber fuer ELZET-80 Microcomputer	*
;*								*
;****************************************************************

	; 
	; ****************
	; Variable
	; ****************
	;
	; bei der Bankzuweisung ist zu beachten, dass ein
	; CP/M3 System MINDESTENS 2 Banks (00 und 01) benoetigt
	; der RAM-Floppy (RF) zugewiesene Bankbereiche duerfen
	; ueber GENCPM nicht nocheinmal zugewiesen werden.
	;

   	
   IF	Z80ASM
   if	askit
	.accept	'Erste Bank     (moeglich ab Bank 2) ',first$bank

   else

first$bank	equ	2	; erste RF-Bank

   endif
   if 	askit

	.accept	'Letzte Bank    (moeglich bis Bank 15) ',last$bank

   else

last$bank	equ	3		; letze RF-Bank

   endif
   ENDIF

rtracks		equ	last$bank-first$bank+1
dirs		defl	64		; DIR-Eintrage
seclen		defl	1024		; Sektorgroesse
	dseg				; Gebankt

	;
	; ****************
	; RF-XDPH
	; ****************
	;

	dw	rf$write
	dw	rf$read
	dw	rf$login
	dw	rf$init
	db	0,0			; Keine Zuweisung
fde:	dph	0,rdpb			; Kein Skew

	cseg				; Gemeinsamer Bereich

   if	rtracks	ge 4
dirs	defl	2*dirs
blklen	defl	2048
rdpb:	dpb	1024,56,rtracks,blklen,dirs,0

   else
dirs	defl	dirs
blklen	defl	1024
rdpb:	dpb	1024,56,rtracks,blklen,dirs,0

   endif
	
	dseg				; gebankter Bereich
	
rf$init:

	;
	; Zur Erkennung der RAMFLOPPY wird eine Leerdatei RDISK in
	; die Directory eingeschrieben. Bei Init wird ueberprueft
	; ob diese Datei angelegt ist.
	;

	ld	bc,first$bank		; dort ist die Directory
	call	?xmove##
	ld	de,0			; Quelle 1. Eintrag
	ld	hl,rf$fcb1		; Ziel
	ld	bc,cmp$len		; muesste reichen zum Vergleichen
	push	hl			; Zeiger retten
	call	?move##			; und Transfer
	pop	hl			; Zeiger auf 'Inhalt' der DIR
	ld	de,rf$fcb0		; Zeiger auf FCB wie gewuenscht
	ld	b,cmp$len		; soviel Zeichen zum Vergleich
rf$in1:	ld	a,(de)			; Zeichen aus FCB0
	cp	(hl)			; gleich FCB1?
	jr	nz,rf$in2		; ... wenn nicht ...
	inc	de
	inc	hl
	djnz	rf$in1			; bis alles klar
	ret				; ... kein INIT notwendig

rf$in2: ld	bc,first$bank shl 8 + 0
	call	?xmove##
	ld	de,rf$fcb0		; original FCB=Quelle
	ld	hl,0			; Ziel
	ld	bc,32			; Laenge
	call	?move##			; und Transfer
	ld	b,dirs-1		; soviel DIR sind leer
rf$in3:	push	bc			; rette DIR-Zaehler
	ld	bc,first$bank shl 8 + 0
	call	?xmove##		; XMOVE init
	ld	de,rf$fcb2		; Dummy-FCB
	ld	bc,32			; Laenge des Dummy
	call	?move##			; Transfer
	pop	bc			; DIR-Zaehler
	djnz	rf$in3
	ret

rf$fcb0:db	20h,'RAMDISK ',20H,20H,20H,0,0,0,0
	db	0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0

rf$fcb1:ds	7

cmp$len	equ	$-rf$fcb1
rf$fcb2:rept	32
	db	0E5H
	endm

rf$write:

	ld	a,(@trk)		; TRACK=Zielbank
	add	a,first$bank		; +Offset berechnen
	ld	b,a			; --> Ziel
	ld	a,(@dbnk)		; Quellbank
	ld	c,a			; --> Quelle
	call	?xmove##		; XMOVE initialisieren
	call	r$calc			; Berechne RAM-Adresse
	jp	?move##

rf$read:

	ld	a,(@trk)		; TRACK=Quellbank
	add	a,first$bank	
	ld	c,a
	ld	a,(@dbnk)		; Zielbank
	ld	b,a
	call	?xmove##
	call	r$calc
	ex	de,hl	
	jp	?move##

r$calc:

	;
	; Berechnen der Quell- bzw Zielparameter
	; zurueck mit:
	; <HL> Zeiger auf RF-SEKTOR-Anfang
	; <DE> Zeiger auf DMA-Adresse
	;

	ld	a,(@sect)		; Sektor Nummer
	ld	h,a			; Berechnen RAM-Start
	ld	l,0
	add	hl,hl			; *2
	add	hl,hl			; *4 = Sektoranfangsadresse
	ld	de,(@dma)		; DMA-Adresse
	ld	bc,seclen		; Sektorgroesse

rf$login:

	ret

